## openshadinglanguage 1.4.2

=== CMakeLists.txt ===
project (OSL)

# Release version of the library
set (OSL_LIBRARY_VERSION_MAJOR 1)
set (OSL_LIBRARY_VERSION_MINOR 4)
set (OSL_LIBRARY_VERSION_PATCH 2)
set (OSL_LIBRARY_VERSION_RELEASE_TYPE "")   # "dev", "betaX", "RCY", ""

# Version of the OSO file format and instruction set
set (OSO_FILE_VERSION_MAJOR 1)
set (OSO_FILE_VERSION_MINOR 0)

cmake_minimum_required (VERSION 2.6)
if (NOT CMAKE_VERSION VERSION_LESS 2.8.4)
    cmake_policy (SET CMP0017 NEW)
endif ()
set (CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
message (STATUS "Project source dir = ${PROJECT_SOURCE_DIR}")
message (STATUS "Project build dir = ${CMAKE_BINARY_DIR}")

if ("${PROJECT_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message (FATAL_ERROR "Not allowed to run in-source build!")
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "Release")
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set (DEBUGMODE ON)
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    # cmake bug workaround -- on some platforms, cmake doesn't set
    # NDEBUG for RelWithDebInfo mode
    add_definitions ("-DNDEBUG")
endif ()

option (CMAKE_USE_FOLDERS "Use the FOLDER target property to organize targets into folders." ON)
mark_as_advanced (CMAKE_USE_FOLDERS)
if (CMAKE_USE_FOLDERS)
    set_property (GLOBAL PROPERTY USE_FOLDERS ON)
endif ()

# Figure out which compiler we're using
if (CMAKE_COMPILER_IS_GNUCC)
    execute_process (COMMAND ${CMAKE_C_COMPILER} -dumpversion
                     OUTPUT_VARIABLE GCC_VERSION
                     OUTPUT_STRIP_TRAILING_WHITESPACE)
    message (STATUS "Using gcc ${GCC_VERSION} as the compiler")
endif ()
message (STATUS "CMAKE_CXX_COMPILER is ${CMAKE_CXX_COMPILER}")
message (STATUS "CMAKE_CXX_COMPILER_ID is ${CMAKE_CXX_COMPILER_ID}")
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set (CMAKE_COMPILER_IS_CLANG 1)
    message (STATUS "Using clang as the compiler")
endif ()
# Second try: for earlier versions of CMake, the CMAKE_CXX_COMPILER_ID
# appears to be unreliable and may say "GNU" despite using clang, so
# directly match against the compiler name.
if ("${CMAKE_CXX_COMPILER}" MATCHES ".*clang.*")
    set (CMAKE_COMPILER_IS_CLANG 1)
    message (STATUS "The compiler seems to be clang")
endif ()

## turn on more detailed warnings and consider warnings as errors
set (STOP_ON_WARNING ON CACHE BOOL "Stop building if there are any compiler warnings")
if (NOT MSVC)
    add_definitions ("-Wall")
    if (STOP_ON_WARNING)
        add_definitions ("-Werror")
    endif ()
endif ()

## enable RTTI
##   NOTE: LLVM builds without RTTI by default so beware
##   if you find the need to turn this on, to use OSL in a
##   project that requires RTTI for example, you need to build
##   LLVM with RRTI, otherwise OSL classes extending LLVM ones
##   will cause linker errors.
set (ENABLERTTI OFF CACHE BOOL "Build with RTTI. Requires a LLVM build with RTTI enabled.")

if (NOT ENABLERTTI)
    if (MSVC)
        set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GR-" )
    else ()
        set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti" )
    endif()

    # For gcc < 4.3, Boost needs some extra help detecting that we've
    # disabled RTTI.
    if ((CMAKE_COMPILER_IS_GNUCC AND GCC_VERSION VERSION_LESS 4.3)
        OR CMAKE_COMPILER_IS_CLANG)
        add_definitions ("-DBOOST_NO_RTTI")
        add_definitions ("-DBOOST_NO_TYPEID")
    endif ()
endif()

# Needed for static boost libraries on Windows
if (WIN32 AND Boost_USE_STATIC_LIBS)
    add_definitions ("-DBOOST_ALL_NO_LIB")
    add_definitions ("-DBOOST_THREAD_USE_LIB")
endif ()

# Needed to disable dllimport/dllexport for static library
if (BUILDSTATIC)
    add_definitions ("-DOSL_STATIC_LIBRARY")
endif()

if (CMAKE_COMPILER_IS_CLANG OR CMAKE_COMPILER_IS_GNUCC)
    # CMake doesn't automatically know what do do with
    # include_directories(SYSTEM...) when using clang or gcc.
    set (CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
endif ()

if (CMAKE_COMPILER_IS_CLANG)
    # disable warning about unused command line arguments
    add_definitions ("-Qunused-arguments -Wno-unknown-pragmas")
    # disable warning in flex-generated code
    add_definitions ("-Wno-null-conversion")
endif ()

if (CMAKE_COMPILER_IS_CLANG OR CMAKE_COMPILER_IS_GNUCC)
    if (HIDE_SYMBOLS AND NOT DEBUGMODE)
        # Turn default symbol visibility to hidden
        set (VISIBILITY_COMMAND "-fvisibility=hidden")
        add_definitions (${VISIBILITY_COMMAND})
    endif ()
    if (LLVM_STATIC AND ${CMAKE_SYSTEM_NAME} STREQUAL "Linux" AND NOT DEBUGMODE)
        # Linux: When linking against LLVM statically, we can also hide
        # all its symbols to prevent clashes if OSL is linked against an
        # app that also embeds LLVM.
        set (VISIBILITY_MAP_COMMAND "-Wl,--version-script=${PROJECT_SOURCE_DIR}/src/liboslexec/liboslexec.map")
    endif ()
endif ()

# Try to detect if this is an OSX distro new enough that the system library
# is libc++, in which case we should force use of Boost Wave (because that
# avoids a nonstandard g++ extension in the other code path).
if (EXISTS "/usr/lib/libc++.dylib" OR OSL_USE_LIBCPP)
    set (OSL_SYSTEM_HAS_LIBCPP ON)
endif ()

set (VERBOSE OFF CACHE BOOL "Print lots of messages while compiling")
set (BUILDSTATIC OFF CACHE BOOL "Build static library instead of shared")
set (HIDE_SYMBOLS OFF CACHE BOOL "Hide symbols not in the public API")
set (USE_EXTERNAL_PUGIXML OFF CACHE BOOL
     "Use an externally built shared library version of the pugixml library")
set (PUGIXML_HOME "" CACHE STRING "Hint about where to find external PugiXML library")
if (WIN32)
    set (USE_LLVM_BITCODE OFF CACHE BOOL "Generate embedded LLVM bitcode")
else ()
    set (USE_LLVM_BITCODE ON CACHE BOOL "Generated embedded LLVM bitcode")
endif ()
if (WIN32 OR OSL_SYSTEM_HAS_LIBCPP)
    set (USE_BOOST_WAVE ON CACHE BOOL "Use Boost Wave as preprocessor")
else ()
    set (USE_BOOST_WAVE OFF CACHE BOOL "Use Boost Wave as preprocessor")
endif ()
set (USE_PARTIO ON CACHE BOOL "Use Partio if found")

if (LLVM_NAMESPACE)
    add_definitions ("-DLLVM_NAMESPACE=${LLVM_NAMESPACE}")
endif ()

if (USE_EXTERNAL_PUGIXML)
    add_definitions ("-DUSE_EXTERNAL_PUGIXML")
endif ()

if (EXTRA_CPP_DEFINITIONS)
    add_definitions ("${EXTRA_CPP_DEFINITIONS}")
endif()

if (USE_BOOST_WAVE)
    add_definitions ("-DUSE_BOOST_WAVE")
endif ()

if (CMAKE_COMPILER_IS_CLANG AND OSL_USE_LIBCPP)
    message (STATUS "Using libc++")
    add_definitions ("-stdlib=libc++")
endif ()

set (CMAKE_MODULE_PATH
     "${PROJECT_SOURCE_DIR}/src/cmake/modules"
     "${PROJECT_SOURCE_DIR}/src/cmake")

include (util_macros)
include (platform)
include (oiio)
include (externalpackages)
include (flexbison)
include_directories (
      "${CMAKE_SOURCE_DIR}/src/include"
      "${CMAKE_BINARY_DIR}/include"
      "${OPENIMAGEIO_INCLUDES}"
  )

if (OSL_NAMESPACE)
    add_definitions ("-DOSL_NAMESPACE=${OSL_NAMESPACE}")
endif ()

# use, i.e. don't skip the full RPATH for the build tree
set (CMAKE_SKIP_BUILD_RPATH  FALSE)
# when building, don't use the install RPATH already
# (but later on when installing)
set (CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
# the RPATH to be used when installing
set (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

message (STATUS "CMAKE_INSTALL_RPATH = ${CMAKE_INSTALL_RPATH}")


###########################################################################
if (MSVC)
    add_definitions (-D_CRT_SECURE_NO_DEPRECATE)
    add_definitions (-D_CRT_SECURE_NO_WARNINGS)
    add_definitions (-D_CRT_NONSTDC_NO_WARNINGS)
    add_definitions (-D_SCL_SECURE_NO_WARNINGS)
endif (MSVC)


# We want CTest for testing
# N.B. This needs to be added before any of the subdirectories, or
# their add_test commands will not register.
include (CTest)


# Tell CMake to process the sub-directories
add_subdirectory (src/liboslcomp)
add_subdirectory (src/liboslquery)
add_subdirectory (src/liboslexec)

add_subdirectory (src/oslc)
add_subdirectory (src/shaders)
add_subdirectory (src/oslinfo)
add_subdirectory (src/testshade)
add_subdirectory (src/testrender)

add_subdirectory (src/include)
add_subdirectory (src/doc)



#########################################################################
# Testing

# Make a copy of the testsuite into the build area
if (DEFINED CMAKE_VERSION AND NOT CMAKE_VERSION VERSION_LESS 2.8)
    file (COPY "${PROJECT_SOURCE_DIR}/testsuite"
          DESTINATION "${CMAKE_BINARY_DIR}")
endif()

macro ( TESTSUITE )
    parse_arguments (_ats "LABEL" "" ${ARGN})
    # If there was a FOUNDVAR param specified and that variable name is
    # not defined, mark the test as broken.
    if (_ats_FOUNDVAR AND NOT ${_ats_FOUNDVAR})
        set (_ats_LABEL "broken")
    endif ()
    # Add the tests if all is well.
    foreach (_testname ${_ats_DEFAULT_ARGS})
        set (_testdir "${CMAKE_BINARY_DIR}/testsuite/${_testname}")
        if (_ats_LABEL MATCHES "broken")
            set (_testname "${_testname}-broken")
        endif ()
        set (_runtest python "${CMAKE_BINARY_DIR}/testsuite/runtest.py"
                             ${_testdir} ${_extra_test_args})
        if (MSVC_IDE)
            set (_runtest ${_runtest} --devenv-config $<CONFIGURATION>
                                      --solution-path "${CMAKE_BINARY_DIR}" )
        endif ()

        if (VERBOSE)
            message (STATUS "TEST ${_testname}: ${CMAKE_BINARY_DIR}/testsuite/runtest.py ${_testdir} ${_extra_test_args}")
        endif ()

        # Run the test unoptimized
        if (NOT _testname MATCHES "^render")
          set (_env TESTSHADE_OPT=0 OPENIMAGEIOHOME=${OPENIMAGEIOHOME})
          add_test ( NAME ${_testname}
                     COMMAND env ${_env} ${_runtest} )
        endif ()
        # Run the same test again with aggressive -O2 runtime
        # optimization, triggered by setting TESTSHADE_OPT env variable
        set (_env TESTSHADE_OPT=2 OPENIMAGEIOHOME=${OPENIMAGEIOHOME})
        add_test ( NAME ${_testname}.opt
                   COMMAND env ${_env} ${_runtest} )
    endforeach ()
endmacro ()

# List all the individual testsuite tests here, except those that need
# special installed tests.
#TESTSUITE ( oslc-empty )
TESTSUITE ( aastep arithmetic array array-derivs array-range
            blackbody blendmath breakcont
            bug-array-heapoffsets
            bug-locallifetime bug-outputinit bug-peep
            cellnoise closure color comparison
            component-range const-array-params debugnan debug-uninit
            derivs derivs-muldiv-clobber error-dupes exit exponential
            function-earlyreturn function-simple function-outputelem
            geomath getsymbol-nonheap gettextureinfo hyperb
            ieee_fp if incdec initops intbits isconnected
            layers layers-Ciassign layers-lazy
            logic loop matrix message metadata-braces miscmath missing-shader
            noise noise-cell
            noise-gabor noise-gabor2d-filter noise-gabor3d-filter
            noise-perlin noise-uperlin noise-simplex noise-usimplex
            pnoise pnoise-cell pnoise-gabor pnoise-perlin pnoise-uperlin
            oslc-D
            oslc-err-arrayindex oslc-err-closuremul
            oslc-err-format oslc-err-intoverflow
            oslc-err-noreturn oslc-err-paramdefault
            pointcloud pointcloud-fold
            raytype render-background render-bumptest render-cornell render-furnace-diffuse
            render-microfacet render-oren-nayar render-veachmis render-ward
            shortcircuit spline splineinverse string 
            struct struct-array struct-array-mixture
            struct-err struct-layers struct-with-array 
            struct-within-struct ternary
            texture-alpha texture-blur texture-field3d
            texture-firstchannel texture-interp 
            texture-missingcolor texture-simple

=== Makefile ===
#########################################################################
#
# This is the master makefile.
# Here we put all the top-level make targets, platform-independent
# rules, etc.
#
# Run 'make help' to list helpful targets.
#
#########################################################################


.PHONY: all debug profile clean realclean nuke doxygen

working_dir	:= ${shell pwd}
INSTALLDIR=${working_dir}

# Figure out which architecture we're on
include ${working_dir}/src/make/detectplatform.mk

# Presence of make variables DEBUG and PROFILE cause us to make special
# builds, which we put in their own areas.
ifdef DEBUG
    variant +=.debug
endif
ifdef PROFILE
    variant +=.profile
endif

MY_MAKE_FLAGS ?=
MY_CMAKE_FLAGS ?= -g3

# Site-specific build instructions
ifndef OSL_SITE
    OSL_SITE := ${shell uname -n}
endif
$(info OSL_SITE = ${OSL_SITE})
ifneq (${shell echo ${OSL_SITE} | grep imageworks},)
include ${working_dir}/site/spi/Makefile-bits
endif

ifneq (${VERBOSE},)
MY_MAKE_FLAGS += VERBOSE=${VERBOSE}
MY_CMAKE_FLAGS += -DVERBOSE:BOOL=1
TEST_FLAGS += -V
endif

ifneq (${LLVM_DIRECTORY},)
MY_CMAKE_FLAGS += -DLLVM_DIRECTORY:STRING=${LLVM_DIRECTORY}
endif

ifneq (${LLVM_VERSION},)
MY_CMAKE_FLAGS += -DLLVM_VERSION:STRING=${LLVM_VERSION}
endif

ifneq (${LLVM_NAMESPACE},)
MY_CMAKE_FLAGS += -DLLVM_NAMESPACE:STRING=${LLVM_NAMESPACE}
endif

ifneq (${LLVM_STATIC},)
MY_CMAKE_FLAGS += -DLLVM_STATIC:BOOL=${LLVM_STATIC}
endif

ifneq (${USE_LLVM_BITCODE},)
MY_CMAKE_FLAGS += -DUSE_LLVM_BITCODE:BOOL=${USE_LLVM_BITCODE}
endif

ifneq (${NAMESPACE},)
MY_CMAKE_FLAGS += -DOSL_NAMESPACE:STRING=${NAMESPACE}
endif

ifneq (${HIDE_SYMBOLS},)
MY_CMAKE_FLAGS += -DHIDE_SYMBOLS:BOOL=${HIDE_SYMBOLS}
endif

ifneq (${USE_BOOST_WAVE},)
MY_CMAKE_FLAGS += -DUSE_BOOST_WAVE:BOOL=${USE_BOOST_WAVE}
endif

ifneq (${ILMBASE_HOME},)
MY_CMAKE_FLAGS += -DILMBASE_HOME:STRING=${ILMBASE_HOME}
endif

ifneq (${USE_PARTIO},)
MY_CMAKE_FLAGS += -DUSE_PARTIO:BOOL=${USE_PARTIO}
endif

ifneq (${PARTIO_HOME},)
MY_CMAKE_FLAGS += -DPARTIO_HOME:BOOL=${PARTIO_HOME} -DUSE_PARTIO:BOOL=1
endif

ifneq (${STOP_ON_WARNING},)
MY_CMAKE_FLAGS += -DSTOP_ON_WARNING:BOOL=${STOP_ON_WARNING}
endif

ifneq (${BUILDSTATIC},)
MY_CMAKE_FLAGS += -DBUILDSTATIC:BOOL=${BUILDSTATIC}
endif

ifneq (${USE_EXTERNAL_PUGIXML},)
MY_CMAKE_FLAGS += -DUSE_EXTERNAL_PUGIXML:BOOL=${USE_EXTERNAL_PUGIXML} -DPUGIXML_HOME=${PUGIXML_HOME}
endif

ifneq (${USE_LIBCPP},)
MY_CMAKE_FLAGS += -DOSL_USE_LIBCPP:BOOL=${USE_LIBCPP}
endif

ifdef DEBUG
MY_CMAKE_FLAGS += -DCMAKE_BUILD_TYPE:STRING=Debug
endif

ifdef PROFILE
MY_CMAKE_FLAGS += -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo
endif

ifneq (${MYCC},)
MY_CMAKE_FLAGS += -DCMAKE_C_COMPILER:STRING=${MYCC}
endif
ifneq (${MYCXX},)
MY_CMAKE_FLAGS += -DCMAKE_CXX_COMPILER:STRING=${MYCXX}
endif

ifneq (${TEST},)
TEST_FLAGS += -R ${TEST}
endif

#$(info MY_CMAKE_FLAGS = ${MY_CMAKE_FLAGS})
#$(info MY_MAKE_FLAGS = ${MY_MAKE_FLAGS})


# Set up variables holding the names of platform-dependent directories --
# set these after evaluating site-specific instructions
top_build_dir := build
build_dir     := ${top_build_dir}/${platform}${variant}
top_dist_dir  := dist
dist_dir      := ${top_dist_dir}/${platform}${variant}

$(info dist_dir = ${dist_dir})
$(info INSTALLDIR = ${INSTALLDIR})


#########################################################################




#########################################################################
# Top-level documented targets

all: dist

# 'make debug' is implemented via recursive make setting DEBUG
debug:
	${MAKE} DEBUG=1 --no-print-directory

# 'make profile' is implemented via recursive make setting PROFILE
profile:
	${MAKE} PROFILE=1 --no-print-directory

# 'make cmakesetup' constructs the build directory and runs 'cmake' there,
# generating makefiles to build the project.  For speed, it only does this when
# ${build_dir}/Makefile doesn't already exist, in which case we rely on the
# cmake generated makefiles to regenerate themselves when necessary.
cmakesetup:
	@ (if [ ! -e ${build_dir}/Makefile ] ; then \
		cmake -E make_directory ${build_dir} ; \
		cd ${build_dir} ; \
		cmake -DCMAKE_INSTALL_PREFIX=${INSTALLDIR}/${dist_dir} \
			${MY_CMAKE_FLAGS} -DBOOST_ROOT=${BOOST_HOME} \
			../.. ; \
	 fi)

# 'make cmake' does a basic build (after first setting it up)
cmake: cmakesetup
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} )

# 'make cmakeinstall' builds everthing and installs it in 'dist'
cmakeinstall: cmake
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} install )

# 'make dist' is just a synonym for 'make cmakeinstall'
dist : cmakeinstall

# 'make test' does a full build and then runs all tests
test: cmake
	cmake -E cmake_echo_color --switch=$(COLOR) --cyan "Running tests ${TEST_FLAGS}..."
	( cd ${build_dir} ; ctest --force-new-ctest-process ${TEST_FLAGS} -E broken )

# 'make testall' does a full build and then runs all tests (even the ones
# that are expected to fail on some platforms)
testall: cmake
	cmake -E cmake_echo_color --switch=$(COLOR) --cyan "Running all tests ${TEST_FLAGS}..."
	( cd ${build_dir} ; ctest --force-new-ctest-process ${TEST_FLAGS} )

# 'make package' builds everything and then makes an installable package 
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package: cmakeinstall
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} package )

# 'make package_source' makes an installable source package 
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package_source: cmakeinstall
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} package_source )

#clean: testclean
# 'make clean' clears out the build directory for this platform
clean:
	cmake -E remove_directory ${build_dir}

# 'make realclean' clears out both build and dist directories for this platform
realclean: clean
	cmake -E remove_directory ${dist_dir}

# 'make nuke' blows away the build and dist areas for all platforms
nuke:
	cmake -E remove_directory ${top_build_dir}
	cmake -E remove_directory ${top_dist_dir}

doxygen:
	doxygen src/doc/Doxyfile

#########################################################################



# 'make help' prints important make targets
help:
	@echo "Targets:"
	@echo "  make              Build optimized binaries and libraries in ${dist_dir},"
	@echo "                        temporary build files in ${build_dir}"
	@echo "  make debug        Build unoptimized with symbols in ${dist_dir}.debug,"
	@echo "                        temporary build files in ${build_dir}.debug"
	@echo "  make profile      Build for profiling in ${dist_dir}.profile,"
	@echo "                        temporary build files in ${build_dir}.profile"
	@echo "  make clean        Remove the temporary files in ${build_dir}"
	@echo "  make realclean    Remove both ${build_dir} AND ${dist_dir}"
	@echo "  make nuke         Remove ALL of build and dist (not just ${platform})"
	@echo "  make test         Run tests"
	@echo "  make testall      Run all tests, even broken ones"
	@echo "  make doxygen      Build the Doxygen docs in ${top_build_dir}/doxygen"
	@echo ""
	@echo "Helpful modifiers:"
	@echo "  make VERBOSE=1 ...          Show all compilation commands"
	@echo "  make MYCC=xx MYCXX=yy ...   Use custom compilers"
	@echo "  make OSL_SITE=xx            Use custom site build mods"
	@echo "  make LLVM_VERSION=2.9 ...   Specify which LLVM version to use"
	@echo "  make LLVM_DIRECTORY=xx ...  Specify where LLVM lives"
	@echo "  make LLVM_NAMESPACE=xx ...  Specify custom LLVM namespace"
	@echo "  make LLVM_STATIC=1          Use static LLVM libraries"
	@echo "  make USE_LLVM_BITCODE=0     Don't generate embedded LLVM bitcode"
	@echo "  make NAMESPACE=name         Wrap OSL APIs in another namespace"
	@echo "  make HIDE_SYMBOLS=1         Hide symbols not in the public API"
	@echo "  make USE_BOOST_WAVE=1       Use Boost 'wave' insted of cpp"
	@echo "  make ILMBASE_HOME=path ...  Custom Ilmbase installation"
	@echo "  make PARTIO_HOME=...        Use Partio from the given location"
	@echo "  make STOP_ON_WARNING=0      Do not stop building if compiler warns"
	@echo "  make BUILDSTATIC=1 ...      Build static library instead of shared"
	@echo "  make USE_EXTERNAL_PUGIXML=1 Use the system PugiXML, not the one in OIIO"
	@echo "  make USE_LIBCPP=1           Use libc++"
	@echo ""

=== src/doc/CMakeLists.txt ===
set (public_docs osl-languagespec.pdf)
# Some day: CLA-INDIVIDUAL CLA-CORPORATE

install (FILES ${public_docs} DESTINATION doc COMPONENT documentation)

install ( FILES "${PROJECT_SOURCE_DIR}/LICENSE"
                "${PROJECT_SOURCE_DIR}/INSTALL"
                "${PROJECT_SOURCE_DIR}/CHANGES"
                "${PROJECT_SOURCE_DIR}/README.md"
          DESTINATION . )

=== src/doc/Makefile ===
PDFLATEX_FLAGS = -interaction=errorstopmode   ###  "--shell-escape"


# by default, just make the document
all: languagespec.pdf


# document making rule: use pdflatex
languagespec.pdf: *.tex languagespec.aux macros.aux Figures/*.pdf Figures/*png
	pdflatex ${PDFLATEX_FLAGS} languagespec.tex



# special command 'make index' to regenerate the index
index: languagespec_index

languagespec_index:
	pdflatex ${PDFLATEX_FLAGS} languagespec.tex
	pdflatex ${PDFLATEX_FLAGS} languagespec.tex
	makeindex languagespec
	pdflatex ${PDFLATEX_FLAGS} languagespec.tex

=== src/include/CMakeLists.txt ===
set (public_headers accum.h dual.h dual_vec.h
                    export.h genclosure.h Imathx.h matrix22.h optautomata.h oslclosure.h
                    oslcomp.h oslconfig.h oslexec.h oslquery.h )
message (STATUS "Create oslversion.h from oslversion.h.in")
configure_file (oslversion.h.in "${CMAKE_BINARY_DIR}/include/oslversion.h" @ONLY)
list (APPEND public_headers "${CMAKE_BINARY_DIR}/include/oslversion.h")

INSTALL ( FILES ${public_headers} DESTINATION include/OSL )

=== src/liboslcomp/CMakeLists.txt ===
SET ( liboslcomp_srcs ast.cpp codegen.cpp oslcomp.cpp symtab.cpp typecheck.cpp
    )

# oslexec symbols used in oslcomp
if (NOT BUILDSTATIC)
    LIST(APPEND liboslcomp_srcs
        ../liboslexec/oslexec.cpp
        ../liboslexec/typespec.cpp
        )
endif ()

FILE ( GLOB compiler_headers "*.h" )

FLEX_BISON ( osllex.l oslgram.y osl liboslcomp_srcs compiler_headers )

if (BUILDSTATIC)
    ADD_LIBRARY ( oslcomp STATIC ${liboslcomp_srcs} )
    ADD_DEFINITIONS ( -DBUILD_STATIC=1 )
else ()
    ADD_LIBRARY ( oslcomp SHARED ${liboslcomp_srcs} )
endif ()

TARGET_LINK_LIBRARIES ( oslcomp ${OPENIMAGEIO_LIBRARY} ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
LINK_ILMBASE ( oslcomp )

if (BUILDSTATIC)
    INSTALL ( TARGETS oslcomp LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
else ()
    INSTALL ( TARGETS oslcomp LIBRARY DESTINATION lib )
endif ()

=== src/liboslexec/CMakeLists.txt ===
SET ( liboslexec_srcs
          shadingsys.cpp closure.cpp
          emissive.cpp background.cpp debug.cpp dictionary.cpp
          vol_subsurface.cpp
          context.cpp instance.cpp 
          loadshader.cpp master.cpp 
          opcolor.cpp 
          opmessage.cpp
          opnoise.cpp simplexnoise.cpp gabornoise.cpp
          opspline.cpp opstring.cpp
          oslexec.cpp osoreader.cpp
          pointcloud.cpp rendservices.cpp 
          constfold.cpp runtimeoptimize.cpp typespec.cpp
          lpexp.cpp lpeparse.cpp automata.cpp accum.cpp
          opclosure.cpp builtin_closures.cpp
          llvm_gen.cpp llvm_instance.cpp llvm_util.cpp
          bsdf.cpp bsdf_diffuse.cpp bsdf_microfacet.cpp bsdf_phong.cpp
          bsdf_westin.cpp bsdf_ashikhmin_velvet.cpp
          bsdf_cloth_fncs.cpp bsdf_cloth.cpp bsdf_cloth_specular.cpp
          bsdf_reflection.cpp bsdf_refraction.cpp bsdf_transparent.cpp bsdf_ward.cpp
          bssrdf.cpp bsdf_hair.cpp bsdf_fakefur.cpp
    )

# oslcomp symbols used in oslexec
if (NOT BUILDSTATIC)
    LIST(APPEND liboslexec_srcs
        ../liboslcomp/ast.cpp
        ../liboslcomp/codegen.cpp
        ../liboslcomp/oslcomp.cpp
        ../liboslcomp/symtab.cpp
        ../liboslcomp/typecheck.cpp
        )
endif ()

include_directories ( "${CMAKE_SOURCE_DIR}/src/liboslcomp" )

FILE ( GLOB exec_headers "*.h" )

FLEX_BISON ( osolex.l osogram.y oso liboslexec_srcs exec_headers )

SET ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS" )

MACRO ( LLVM_COMPILE llvm_src srclist )
    GET_FILENAME_COMPONENT ( llvmsrc_we ${llvm_src} NAME_WE )
    SET ( llvm_asm "${CMAKE_CURRENT_BINARY_DIR}/${llvmsrc_we}.s" )
    SET ( llvm_bc "${CMAKE_CURRENT_BINARY_DIR}/${llvmsrc_we}.bc" )
    SET ( llvm_bc_cpp "${CMAKE_CURRENT_BINARY_DIR}/${llvmsrc_we}.bc.cpp" )
    if (VERBOSE)
        MESSAGE (STATUS "LLVM_COMPILE in=${llvm_src}")
        MESSAGE (STATUS "LLVM_COMPILE asm=${llvm_asm}")
        MESSAGE (STATUS "LLVM_COMPILE bc=${llvm_bc}")
        MESSAGE (STATUS "LLVM_COMPILE cpp=${llvm_bc_cpp}")
    endif ()
    SET ( ${srclist} ${${srclist}} ${llvm_bc_cpp} )
    EXEC_PROGRAM ( "${LLVM_DIRECTORY}/bin/llvm-config" ARGS --cxxflags OUTPUT_VARIABLE LLVM_COMPILE_FLAGS )
    set (LLVM_COMPILE_FLAGS "${LLVM_COMPILE_FLAGS} -D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS -O3 --combine")
    if (OSL_NAMESPACE)
        LIST (APPEND LLVM_COMPILE_FLAGS "-DOSL_NAMESPACE=${OSL_NAMESPACE}")
    endif ()
    if (OPENIMAGEIO_NAMESPACE)
        LIST (APPEND LLVM_COMPILE_FLAGS "-DOPENIMAGEIO_NAMESPACE=${OPENIMAGEIO_NAMESPACE}")
    endif ()
    get_property (CURRENT_DEFINITIONS DIRECTORY PROPERTY COMPILE_DEFINITIONS)
    if (VERBOSE)
        message (STATUS "Current #defines are ${CURRENT_DEFINITIONS}")
    endif ()
    foreach (def ${CURRENT_DEFINITIONS})
      LIST (APPEND LLVM_COMPILE_FLAGS "-D${def}")
    endforeach()

    # First try looking in their build (clang++ first, then llvm-g++)
    FIND_PROGRAM(LLVM_BC_GENERATOR NAMES "clang++" "llvm-g++" PATHS "${LLVM_DIRECTORY}/bin" NO_DEFAULT_PATH NO_CMAKE_SYSTEM_PATH NO_SYSTEM_ENVIRONMENT_PATH NO_CMAKE_ENVIRONMENT_PATH NO_CMAKE_PATH)

    if(NOT LLVM_BC_GENERATOR)
      # Wasn't in their build, look anywhere
      FIND_PROGRAM(LLVM_BC_GENERATOR NAMES clang++ llvm-g++)
    endif()

    if(NOT LLVM_BC_GENERATOR)
      message (FATAL_ERROR "You must have a valid llvm bitcode generator (either llvm-g++ or clang++) somewhere.")
    else()
      if (VERBOSE)
          message (STATUS "Using ${LLVM_BC_GENERATOR} to generate bitcode.")
      endif ()
    endif()

    # Command to turn the .cpp file into LLVM assembly language .s, into
    # LLVM bitcode .bc, then back into a C++ file with the bc embedded!
    ADD_CUSTOM_COMMAND ( OUTPUT ${llvm_bc_cpp}
      COMMAND ${LLVM_BC_GENERATOR}
      "-I${CMAKE_CURRENT_SOURCE_DIR}"
      "-I${CMAKE_SOURCE_DIR}/src/include"
      "-I${CMAKE_BINARY_DIR}/include"
      "-I${OPENIMAGEIO_INCLUDES}"
      "-I${ILMBASE_INCLUDE_DIR}"
      "-I${Boost_INCLUDE_DIRS}"
      ${LLVM_COMPILE_FLAGS}
      -O3 -S -emit-llvm -o ${llvm_asm} ${llvm_src}

      COMMAND "${LLVM_DIRECTORY}/bin/llvm-as" -f -o ${llvm_bc} ${llvm_asm}
      COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/serialize-bc.bash" ${llvm_bc} ${llvm_bc_cpp}
      MAIN_DEPENDENCY ${llvm_src}
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/serialize-bc.bash"
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" )
ENDMACRO ( )

if (USE_LLVM_BITCODE)
    LLVM_COMPILE ( llvm_ops.cpp liboslexec_srcs )
else ()
    # With MSVC/Mingw, we don't compile llvm_ops.cpp to LLVM bitcode, due
    # to clang being unable to compile MSVC C++ header files at this time.
    # Instead it is part of the regular build process.
    ADD_DEFINITIONS (-DOSL_LLVM_NO_BITCODE)
    SET (liboslexec_srcs ${liboslexec_srcs} llvm_ops.cpp)
endif ()

if (BUILDSTATIC)
    ADD_LIBRARY ( oslexec STATIC ${liboslexec_srcs} )
else ()
    ADD_LIBRARY ( oslexec SHARED ${liboslexec_srcs} )
endif ()

TARGET_LINK_LIBRARIES ( oslexec
                        ${VISIBILITY_COMMAND} ${VISIBILITY_MAP_COMMAND}
                        ${OPENIMAGEIO_LIBRARY} ${PUGIXML_LIBRARIES}
                        ${PARTIO_LIBRARIES} ${ZLIB_LIBRARIES}
                        ${Boost_LIBRARIES} ${CMAKE_DL_LIBS}
                        ${LLVM_LIBRARY} ${EXTRA_OSLEXEC_LIBRARIES})
ADD_DEPENDENCIES (oslexec "${CMAKE_CURRENT_SOURCE_DIR}/liboslcexec.map")
LINK_ILMBASE ( oslexec )

if (BUILDSTATIC)
    INSTALL ( TARGETS oslexec LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
else ()
    INSTALL ( TARGETS oslexec LIBRARY DESTINATION lib )
endif ()

# Unit tests
add_executable (closure_test closure_test.cpp)
add_executable (accum_test accum_test.cpp)
target_link_libraries ( closure_test oslexec oslcomp ${Boost_LIBRARIES} ${CMAKE_DL_LIBS} ${LLVM_LIBRARY} ${EXTRA_OSLEXEC_LIBRARIES} )
target_link_libraries ( accum_test oslexec oslcomp ${Boost_LIBRARIES} ${CMAKE_DL_LIBS} ${LLVM_LIBRARY} ${EXTRA_OSLEXEC_LIBRARIES} )
link_ilmbase (closure_test)
link_ilmbase (accum_test)
add_test (unit_closure "${CMAKE_BINARY_DIR}/src/liboslexec/closure_test")
add_test (unit_accum "${CMAKE_BINARY_DIR}/src/liboslexec/accum_test")

=== src/liboslquery/CMakeLists.txt ===
SET ( liboslquery_srcs oslquery.cpp ../liboslexec/osoreader.cpp
      ../liboslexec/typespec.cpp )
FILE ( GLOB compiler_headers "../liboslexec/*.h" )
INCLUDE_DIRECTORIES ( ../liboslexec )

FLEX_BISON ( ../liboslexec/osolex.l ../liboslexec/osogram.y oso liboslquery_srcs compiler_headers )

if (BUILDSTATIC)
    ADD_LIBRARY ( oslquery STATIC ${liboslquery_srcs} )
else ()
    ADD_LIBRARY ( oslquery SHARED ${liboslquery_srcs} )
endif ()

TARGET_LINK_LIBRARIES ( oslquery ${OPENIMAGEIO_LIBRARY} ${Boost_LIBRARIES} )
LINK_ILMBASE ( oslquery )

if (BUILDSTATIC)
    INSTALL ( TARGETS oslquery LIBRARY DESTINATION lib ARCHIVE DESTINATION lib)
else ()
    INSTALL ( TARGETS oslquery LIBRARY DESTINATION lib )
endif ()

=== src/oslc/CMakeLists.txt ===
SET ( oslc_srcs oslcmain.cpp )

# don't want to link oslexec but oslcomp uses these symbols
if (BUILDSTATIC)
    LIST(APPEND oslc_srcs
        ../liboslexec/oslexec.cpp
        ../liboslexec/typespec.cpp)
endif ()

ADD_EXECUTABLE ( oslc ${oslc_srcs} )
LINK_ILMBASE ( oslc )
TARGET_LINK_LIBRARIES ( oslc oslcomp ${OPENIMAGEIO_LIBRARY} ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
INSTALL ( TARGETS oslc RUNTIME DESTINATION bin )

=== src/oslinfo/CMakeLists.txt ===
SET ( oslinfo_srcs oslinfo.cpp )
ADD_EXECUTABLE ( oslinfo ${oslinfo_srcs} )
LINK_ILMBASE ( oslinfo )
TARGET_LINK_LIBRARIES ( oslinfo oslquery ${OPENIMAGEIO_LIBRARY} ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
INSTALL ( TARGETS oslinfo RUNTIME DESTINATION bin )

=== src/shaders/CMakeLists.txt ===
add_custom_command (OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/stdosl.h"
    COMMAND ${CMAKE_COMMAND} -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/stdosl.h" "${CMAKE_CURRENT_BINARY_DIR}"
    MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/stdosl.h"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

macro (osl_compile oslsrc objlist headers)
    # message (STATUS "OSL_COMPILE src=${oslsrc}")
    # message (STATUS "  src ${CMAKE_CURRENT_SOURCE_DIR}")
    # message (STATUS "  bin ${CMAKE_CURRENT_BINARY_DIR}")
    get_filename_component ( oslsrc_we ${oslsrc} NAME_WE )
    set ( osofile "${CMAKE_CURRENT_BINARY_DIR}/${oslsrc_we}.oso" )
    # message (STATUS "  osl output ${osofile}")

    set ( ${objlist} ${${objlist}} ${osofile} )
    # message (STATUS "  obj list now ${${objlist}}")

#    include_directories ( ${CMAKE_CURRENT_BINARY_DIR} )
#    include_directories ( ${CMAKE_CURRENT_SOURCE_DIR} )
    if (VERBOSE)
        message (STATUS "cmd: ${CMAKE_CURRENT_BINARY_DIR}/../oslc/oslc ${oslsrc}")
    endif ()
    add_custom_command (OUTPUT ${osofile}
        COMMAND "${CMAKE_CURRENT_BINARY_DIR}/../oslc/oslc" ${oslsrc}
        MAIN_DEPENDENCY ${oslsrc}
        DEPENDS ${${headers}} ${oslsrc} "${CMAKE_CURRENT_BINARY_DIR}/stdosl.h" "${CMAKE_CURRENT_BINARY_DIR}/../oslc/oslc"
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
endmacro ()




file (GLOB shader_headers "*.h")
file (GLOB shader_source "*.osl")

foreach (_shadername ${shader_source})
    osl_compile (${_shadername} shader_objs shader_headers)
endforeach ()


add_custom_target (shaders ALL
                   DEPENDS ${shader_objs}
                   SOURCES ${shader_source} ${shader_headers})

install (FILES ${shader_headers} ${shader_source} ${shader_objs}
         DESTINATION shaders)

=== src/testrender/CMakeLists.txt ===
# The 'testrender' executable
FILE(GLOB testrender_src *.cpp)
ADD_EXECUTABLE ( testrender ${testrender_src} )
LINK_ILMBASE ( testrender )
TARGET_LINK_LIBRARIES ( testrender oslexec oslcomp oslquery ${OPENIMAGEIO_LIBRARY} ${Boost_LIBRARIES} ${CMAKE_DL_LIBS})
INSTALL ( TARGETS testrender RUNTIME DESTINATION bin )

=== debian/changelog ===
openshadinglanguage (1.4.2-0irie1~precise1) precise; urgency=medium

  * New upstream release
  * debian/testshade.1:
    - Add new options: --debuguninit, --options
    - Update description: --debugnan

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Tue, 20 May 2014 19:58:38 +0900

openshadinglanguage (1.4.1-0irie4~trusty1) trusty; urgency=low

  * debian/rules:
    - Add compiler/linker options to fix FTBFS on some distributions:
        Preciese: -DSPECIAL_COMPILE_FLAGS="-Wno-error=strict-overflow -O2"
        Trusty:   -DEXTRA_OSLEXEC_LIBRARIES="tinfo"

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 26 Mar 2014 00:34:39 +0900

openshadinglanguage (1.4.1-0irie3~saucy1) saucy; urgency=low

  * Use LLVM static library:
    - This is workaround for issue that graphical application such as
      Blender crashes if using Gallium3D-based graphics driver

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Tue, 25 Mar 2014 19:07:50 +0900

openshadinglanguage (1.4.1-0irie2~trusty1) trusty; urgency=low

  * Add patch 040_support_llvm34 to fix FTBFS on Trusty:
    - Backported from master branch 08c7eb99c8ef85426ede781c9d20a398c3efeb33

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 05 Mar 2014 21:20:57 +0900

openshadinglanguage (1.4.1-0irie1~saucy1) saucy; urgency=low

  * New upstream release
  * Move to RB-1.4 branch:
    - Rename shared library package to libopenshadinglanguage1.4
  * Update for some upstream changes:
    - CMakeLists.txt was moved from SRCDIR/src to SRCDIR
    - shaders were moved from BLDDIR/shaders to BLDDIR/src/shaders
  * debian/copyright:
    - Update copyright years

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 01 Jan 2014 11:05:52 +0900

openshadinglanguage (1.3.3-0irie1~saucy2) saucy; urgency=low

  * Build with OpenImageIO 1.2.3

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 06 Nov 2013 22:02:07 +0900

openshadinglanguage (1.3.3-0irie1~raring1) raring; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 10 Aug 2013 22:40:26 +0900

openshadinglanguage (1.3.2-0irie1~raring1) raring; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sun, 30 Jun 2013 22:54:17 +0900

openshadinglanguage (1.3.1-0irie1~raring1) raring; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Mon, 10 Jun 2013 14:26:14 +0900

openshadinglanguage (1.3.0-0irie2~raring1) raring; urgency=low

  * Add patch 010_multiarch_findlibs:
    - Fix FTBFS on Raring (libilmbase not found)

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Fri, 08 Mar 2013 01:17:31 +0900

openshadinglanguage (1.3.0-0irie1~quantal1) quantal; urgency=low

  * New upstream release
  * Move to RB-1.3 branch:
    - Rename shared library package to libopenshadinglanguage1.3
    - Move runtime headers and example shaders to /usr/share/OSL-1.3/shaders
  * Remove patch 010_fix_FTBFS:
    - Fixed upstream
  * debian/docs:
    - Rename README to README.md
  * debian/copyright:
    - Update copyright years

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 16 Feb 2013 14:34:46 +0900

openshadinglanguage (1.2-0irie4~quantal1) quantal; urgency=low

  * debian/control:
    - Fix descriptions
  * Move runtime headers and example shaders:
    - /usr/share/OSL/shaders -> /usr/share/OSL-1.2/shaders
    - Modify debian/rules, debian/libopenshadinglanguage1.2.install,
      debian/oslc.1, and patch 020_fix_implicit_include
  * Modify patch 010_fix_FTBFS:
    - Use cast operator (int) rather than "z" prefix

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Mon, 05 Nov 2012 16:42:21 +0900

openshadinglanguage (1.2-0irie3~quantal1) quantal; urgency=low

  * Modify patch 010_fix_FTBFS:
    - Grr, more fixes for i386 build failure...

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 03 Nov 2012 01:45:32 +0900

openshadinglanguage (1.2-0irie2~quantal1) quantal; urgency=low

  * Modify patch 010_fix_FTBFS:
    - Fix FTBFS on i386 (OSL issue #160)

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Fri, 02 Nov 2012 23:24:04 +0900

openshadinglanguage (1.2-0irie1~quantal1) quantal; urgency=low

  * Initial release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Thu, 01 Nov 2012 23:30:03 +0900

=== debian/control ===
Source: openshadinglanguage
Priority: extra
Maintainer: IRIE Shinsuke <irieshinsuke@yahoo.co.jp>
Build-Depends: debhelper (>= 8.0.0), cmake, chrpath,
	       flex, bison, llvm-dev (>= 3.0), clang (>= 3.0),
	       libopenexr-dev, libopenimageio-dev,
	       libboost-filesystem-dev, libboost-regex-dev,
	       libboost-system-dev, libboost-thread-dev, libtbb-dev
Standards-Version: 3.9.3
Section: graphics
Homepage: https://github.com/imageworks/OpenShadingLanguage

Package: openshadinglanguage
Architecture: any
Depends: libopenshadinglanguage1.4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - compiler
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains command line programs such as OSL compiler.

Package: libopenshadinglanguage-dev
Section: libdevel
Architecture: any
Depends: libopenshadinglanguage1.4 (= ${binary:Version}), ${misc:Depends}
Description: Small but rich language for programmable shading - development
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains header files for building programs that provides
 OSL compiler or OSL shading system.

Package: libopenshadinglanguage1.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - runtime
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package includes shared libraries and runtime data for
 compiling/running OSL programs.  Also includes example shader scripts.

Package: openshadinglanguage-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Small but rich language for programmable shading - document
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains a manual that describes the language specification
 of OSL.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

BLDDIR = debian/cmake
TMPDIR = debian/tmp
DIST := $(shell dpkg-parsechangelog | awk '/^Distribution: / {print $$2}')

# Additional compiler/linker flags to avoid FTBFS on Ubuntu 12.04 and 14.04.
# ("-O2" is not essential for building, just avoids too aggressive optimizations.)
ifeq ($(DIST),precise)
EXTRA_FLAGS = -DSPECIAL_COMPILE_FLAGS:STRING="-Wno-error=strict-overflow -O2"
endif
ifeq ($(DIST),trusty)
EXTRA_FLAGS = -DEXTRA_OSLEXEC_LIBRARIES:STRING="tinfo"
endif

%:
	dh $@ -Scmake -B$(BLDDIR) --parallel

override_dh_auto_configure:
	# Note: currently all tests pass on OS X but a few tests fail on Linux
	#  strictly for floating point precision reasons, not because anything
	#  is really broken.
	# Note2: graphics driver based on Gallium3D also uses LLVM, so we needs
	#  to use LLVM static library to avoid symbol conflicts.
	dh_auto_configure -- \
		-DBUILD_TESTING:BOOL=OFF \
		-DLLVM_STATIC:BOOL=ON \
		$(EXTRA_FLAGS)
	# A patch 020_fix_implicit_include changes the implicit include path to
	# stdosl.h from DESTDIR/shaders to DESTDIR/share/OSL-1.4/shaders.
	mkdir -p $(BLDDIR)/src/share/OSL-1.4
	ln -sf ../../shaders $(BLDDIR)/src/share/OSL-1.4

override_dh_auto_install:
	dh_auto_install
	# CMAKE_SKIP_RPATH cannot be used because it causes build failure.
	chrpath -d $(TMPDIR)/usr/bin/* $(TMPDIR)/usr/lib/lib*.so

override_dh_installchangelogs:
	dh_installchangelogs CHANGES
